(function () {
    "use strict";

    angular.module('core').controller('contaContabilController', controller);
    controller.$inject = ['$scope', '$timeout', '$q', '$stateParams', '$alert', 'contaContabilService', 'lookupService'];

    function controller($scope, $timeout, $q, $stateParams, $alert, contaContabilService, lookupService) {
        $scope.initializeLayout('Contas');

        //[Inicializa objetos]
        $scope.state = {
            data: [],
            carregando: false,
            salvando: false,
            vazio: false,
            count: 0,
            filtro: {
                ativo: false,
                args: {
                    chaves: '',
                    filtro: null,
                    sortExpression: '',
                    skip: 0,
                    take: 20
                }
            }
        };
        $scope.popups = {
            add: {
                ativo: false,
                data: {},
                save: function () {
                    $scope.state.salvando = true;
                    contaContabilService
                        .save($scope.popups.add.data)
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $alert({ title: $scope.Title, text: response.Message });
                            } else {
                                $scope.popups.add.ativo = false;
                                $scope.popups.add.data = {};
                                $scope.refresh();
                            }
                            $scope.state.salvando = false;
                        },
                        function (_error) {
                            $scope.state.salvando = false;
                            $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        });
                },
                toggle: function () {
                    $scope.popups.add.ativo = !$scope.popups.add.ativo
                    if ($scope.popups.add.ativo) {
                        $scope.popups.add.prepare();
                    }
                },
                prepare: function () {
                    contaContabilService
                        .prepareNew()
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $scope.tools.toastr.error(response.Message, 'Serviço');
                                $scope.popups.edit.ativo = false;
                            } else {
                                $scope.popups.add.data = response.Data;
                                $scope.popups.add.ativo = true;
                            }
                        },
                        function (_error) {
                            $scope.popups.edit.ativo = false;
                            $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        });
                },
            },
            edit: {
                ativo: false,
                data: {},
                tabs: { current: 0, subcontas: 0, detalhes: 1 },
                save: function () {
                    $scope.state.salvando = true;
                    contaContabilService
                        .save($scope.popups.edit.data)
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $alert({ title: $scope.Title, text: response.Message });
                            } else {
                                $scope.popups.edit.ativo = false;
                                $scope.popups.edit.data = {};
                                $scope.refresh();
                            }
                            $scope.state.salvando = false;
                        },
                        function (_error) {
                            $scope.state.salvando = false;
                            $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        });
                },
                toggle: function (id) {
                    $scope.popups.edit.ativo = !$scope.popups.edit.ativo
                    if ($scope.popups.edit.ativo && id) {
                        $scope.popups.edit.prepare(id);
                    }
                },
                prepare: function (id) {
                    var args = { id: id };
                    contaContabilService
                        .get(args)
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $alert({ title: $scope.Title, text: response.Message });
                                $scope.popups.edit.ativo = false;
                            } else {
                                $scope.popups.edit.data = response.Data;
                                $scope.popups.edit.ativo = true;
                            }
                        },
                        function (_error) {
                            $scope.popups.edit.ativo = false;
                            $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        });
                },
                prepareNewSubconta: function () {
                    contaContabilService
                        .prepareNewSubconta($scope.popups.edit.data)
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $alert({ title: $scope.Title, text: response.Message });
                            } else {
                                $scope.popups.edit.data = response.Data;
                                $scope.popups.subconta.select($scope.popups.edit.data.Subcontas.length - 1);
                            }
                        },
                        function (_error) {
                            $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        });
                },
                delete: function () {
                    $scope.state.salvando = true;
                    contaContabilService
                        .delete($scope.popups.edit.data.ID)
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $alert({ title: $scope.Title, text: response.Message });
                            } else {
                                $scope.popups.edit.ativo = false;
                                $scope.popups.edit.data = {};
                                $scope.refresh();
                            }
                            $scope.state.salvando = false;
                        },
                        function (_error) {
                            $scope.state.salvando = false;
                            $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        });
                },
            },
            subconta: {
                index: -1,
                data: null,
                select: function (index) {
                    $scope.popups.subconta.index = index;
                    $scope.popups.subconta.data = $scope.popups.edit.data.Subcontas[index];

                    $timeout(function () { $('[ng-model*="popups.subconta.data.Codigo"]').focus(); });
                },
                toggle: function () {
                    if ($scope.popups.subconta.index < 0) {
                        $scope.popups.subconta.index = 0;
                        $scope.popups.subconta.data = $scope.popups.edit.data.Subcontas[$scope.popups.subconta.index];
                    } else {
                        $scope.popups.subconta.index = -1;
                        $scope.popups.subconta.data = null;
                    }
                },
                next: function () {
                    if ($scope.popups.subconta.index < $scope.popups.edit.data.Subcontas.length - 1) {
                        $scope.popups.subconta.index++;
                        $scope.popups.subconta.data = $scope.popups.edit.data.Subcontas[$scope.popups.subconta.index];
                    }
                },
                prior: function () {
                    if ($scope.popups.subconta.index > 0)
                        $scope.popups.subconta.index--;

                    $scope.popups.subconta.data = $scope.popups.edit.data.Subcontas[$scope.popups.subconta.index];
                },
            },
        };
        $scope.auxiliar = {
            banco: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllBanco({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.clearFilter();
            if ($stateParams.id)
                $scope.popups.edit.toggle($stateParams.id);
        };

        $scope.getAll = function () {
            $scope.state.filtro.args.skip = 0;
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            contaContabilService
                .getAll($scope.state.filtro.args)
                .then(
                function (response) {
                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                    } else {
                        angular.copy(angular.fromJson(response.Data), $scope.state.data);
                    }
                    $scope.state.carregando = false;
                    $scope.state.vazio = ($scope.state.data == 0);
                },
                function (_error) {
                    $scope.state.carregando = false;
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                }
                );
        };
        $scope.count = function () {
            contaContabilService
                .count($scope.state.filtro.args)
                .then(
                function (response) {
                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                    } else {
                        $scope.state.count = response.Data;
                    }
                },
                function (_error) {
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                }
                );
        };
        $scope.getMore = function () {
            $scope.state.filtro.args.skip += $scope.state.filtro.args.take;
            contaContabilService
                .getAll($scope.state.filtro.args)
                .then(
                function (response) {
                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                    } else {
                        $scope.state.data = $scope.state.data.concat(response.Data);
                    }
                },
                function (_error) {
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                }
                );
        };
        $scope.refresh = function () {
            $scope.getAll();
            $scope.count();
        };

        $scope.clearFilter = function () {
            $scope.state.filtro.args = {
                chaves: '',
                filtro: null,
                filtroDe: null,
                filtroAte: null,
                sortExpression: '',
                skip: 0,
                take: 20
            };

            $scope.refresh();
        };
        $scope.toggleFilter = function () {
            $scope.state.filtro.ativo = !$scope.state.filtro.ativo;
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();